/* Copyright (C) 2005 TightVNC Team.  All Rights Reserved.
 *
 * Developed by Dennis Syrovatsky.
 *    
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 * USA.
 *
 * TightVNC distribution homepage on the Web: http://www.tightvnc.com/
 *
 */

// -=- FolderManager.h

#ifndef __RFB_WIN32_FOLDERMANAGER_H__
#define __RFB_WIN32_FOLDERMANAGER_H__

#include <windows.h>

#include <rfb/FileInfo.h>
#include <rfb/DirManager.h>

namespace rfb {
  namespace win32{
    class FolderManager : public DirManager {
    public:
      FolderManager();
      ~FolderManager();
      
      bool createDir(const char *pFullPath);

      bool renameIt(const char *pOldName, const char *pNewName);
      bool renameIt(const char *pPath, const char *pOldName, const char *pNewName);
      
      bool deleteIt(const char *pPrefix, FileInfo *pFI);
      bool deleteIt(const char *pFullPath);
      bool deleteIt(FileInfo *pFI);

      bool getInfo(const char *pFullPath, FILEINFO *pFIStruct);
      
      bool getDirInfo(const char *pPath, FileInfo *pFileInfo, unsigned int dirOnly);
      bool getDrivesInfo(FileInfo *pFI);

      unsigned int getTime70(FILETIME ftime);
      void getFiletime(unsigned int time70, FILETIME *pftime);

      bool getDirSize(const char *pFullPath, DWORD64 *dirSize);

    private:
      bool getFolderInfoWithPrefix(const char *pPrefix, FileInfo *pFileInfo);
    };
  }
}

#endif // __RFB_WIN32_FOLDERMANAGER_H__
